/* adaptative-pathbar.c generated by valac 0.45.91, the Vala compiler
 * generated from adaptative-pathbar.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define TYPE_PATHBAR (pathbar_get_type ())
#define PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATHBAR, Pathbar))
#define IS_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATHBAR))
#define PATHBAR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PATHBAR, PathbarIface))

typedef struct _Pathbar Pathbar;
typedef struct _PathbarIface PathbarIface;
typedef enum  {
	VIEW_TYPE_OBJECT,
	VIEW_TYPE_FOLDER,
	VIEW_TYPE_SEARCH,
	VIEW_TYPE_CONFIG
} ViewType;

#define TYPE_VIEW_TYPE (view_type_get_type ())

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())

#define TYPE_ADAPTATIVE_PATHBAR (adaptative_pathbar_get_type ())
#define ADAPTATIVE_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_PATHBAR, AdaptativePathbar))
#define ADAPTATIVE_PATHBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADAPTATIVE_PATHBAR, AdaptativePathbarClass))
#define IS_ADAPTATIVE_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_PATHBAR))
#define IS_ADAPTATIVE_PATHBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADAPTATIVE_PATHBAR))
#define ADAPTATIVE_PATHBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADAPTATIVE_PATHBAR, AdaptativePathbarClass))

typedef struct _AdaptativePathbar AdaptativePathbar;
typedef struct _AdaptativePathbarClass AdaptativePathbarClass;
typedef struct _AdaptativePathbarPrivate AdaptativePathbarPrivate;

#define TYPE_LARGE_PATHBAR (large_pathbar_get_type ())
#define LARGE_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LARGE_PATHBAR, LargePathbar))
#define LARGE_PATHBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LARGE_PATHBAR, LargePathbarClass))
#define IS_LARGE_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LARGE_PATHBAR))
#define IS_LARGE_PATHBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LARGE_PATHBAR))
#define LARGE_PATHBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LARGE_PATHBAR, LargePathbarClass))

typedef struct _LargePathbar LargePathbar;
typedef struct _LargePathbarClass LargePathbarClass;

#define TYPE_SHORT_PATHBAR (short_pathbar_get_type ())
#define SHORT_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHORT_PATHBAR, ShortPathbar))
#define SHORT_PATHBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHORT_PATHBAR, ShortPathbarClass))
#define IS_SHORT_PATHBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHORT_PATHBAR))
#define IS_SHORT_PATHBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHORT_PATHBAR))
#define SHORT_PATHBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHORT_PATHBAR, ShortPathbarClass))

typedef struct _ShortPathbar ShortPathbar;
typedef struct _ShortPathbarClass ShortPathbarClass;
enum  {
	ADAPTATIVE_PATHBAR_0_PROPERTY,
	ADAPTATIVE_PATHBAR_NUM_PROPERTIES
};
static GParamSpec* adaptative_pathbar_properties[ADAPTATIVE_PATHBAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PathbarIface {
	GTypeInterface parent_iface;
	gboolean (*has_popover) (Pathbar* self);
	void (*close_menu) (Pathbar* self);
	void (*toggle_menu) (Pathbar* self);
	void (*set_path) (Pathbar* self, ViewType type, const gchar* path);
	void (*update_ghosts) (Pathbar* self, const gchar* non_ghost_path, gboolean is_search);
	void (*get_complete_path) (Pathbar* self, gchar* * _complete_path);
	void (*get_fallback_path_and_complete_path) (Pathbar* self, gchar* * _fallback_path, gchar* * _complete_path);
	gchar* (*get_selected_child) (Pathbar* self, const gchar* current_path);
};

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _AdaptativePathbar {
	GtkStack parent_instance;
	AdaptativePathbarPrivate * priv;
};

struct _AdaptativePathbarClass {
	GtkStackClass parent_class;
};

struct _AdaptativePathbarPrivate {
	gboolean start_infos_not_given;
	gboolean window_size_not_given;
	gboolean large_pathbar_created;
	gboolean short_pathbar_created;
	LargePathbar* large_pathbar;
	ShortPathbar* short_pathbar;
	gboolean thin_window;
	ViewType current_type;
	gchar* current_path;
	gchar* complete_path;
};

static gint AdaptativePathbar_private_offset;
static gpointer adaptative_pathbar_parent_class = NULL;
static PathbarIface * adaptative_pathbar_pathbar_parent_iface = NULL;
static AdaptativeWidgetIface * adaptative_pathbar_adaptative_widget_parent_iface = NULL;

GType view_type_get_type (void) G_GNUC_CONST;
GType pathbar_get_type (void) G_GNUC_CONST;
GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST;
GType adaptative_widget_get_type (void) G_GNUC_CONST;
GType adaptative_pathbar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativePathbar, g_object_unref)
GType large_pathbar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LargePathbar, g_object_unref)
GType short_pathbar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ShortPathbar, g_object_unref)
static void adaptative_pathbar_create_large_pathbar (AdaptativePathbar* self);
LargePathbar* large_pathbar_new (const gchar* complete_path_or_empty,
                                 ViewType type,
                                 const gchar* path);
LargePathbar* large_pathbar_construct (GType object_type,
                                       const gchar* complete_path_or_empty,
                                       ViewType type,
                                       const gchar* path);
static void adaptative_pathbar_create_short_pathbar (AdaptativePathbar* self);
ShortPathbar* short_pathbar_new (const gchar* complete_path_or_empty,
                                 ViewType type,
                                 const gchar* path);
ShortPathbar* short_pathbar_construct (GType object_type,
                                       const gchar* complete_path_or_empty,
                                       ViewType type,
                                       const gchar* path);
static void adaptative_pathbar_create_initial_pathbar (AdaptativePathbar* self);
static void adaptative_pathbar_real_set_window_size (AdaptativeWidget* base,
                                              AdaptativeWidgetWindowSize new_size);
gboolean adaptative_widget_window_size_is_extra_thin (AdaptativeWidgetWindowSize window_size);
static void adaptative_pathbar_real_set_path (Pathbar* base,
                                       ViewType type,
                                       const gchar* path);
void pathbar_set_path (Pathbar* self,
                       ViewType type,
                       const gchar* path);
static gboolean adaptative_pathbar_real_has_popover (Pathbar* base);
gboolean pathbar_has_popover (Pathbar* self);
static void adaptative_pathbar_real_close_menu (Pathbar* base);
void pathbar_close_menu (Pathbar* self);
static void adaptative_pathbar_real_toggle_menu (Pathbar* base);
void pathbar_toggle_menu (Pathbar* self);
static void adaptative_pathbar_real_get_complete_path (Pathbar* base,
                                                gchar* * _complete_path);
static void adaptative_pathbar_real_get_fallback_path_and_complete_path (Pathbar* base,
                                                                  gchar* * _fallback_path,
                                                                  gchar* * _complete_path);
void pathbar_get_fallback_path_and_complete_path (Pathbar* self,
                                                  gchar* * _fallback_path,
                                                  gchar* * _complete_path);
static void adaptative_pathbar_real_update_ghosts (Pathbar* base,
                                            const gchar* non_ghost_path,
                                            gboolean is_search);
void pathbar_update_ghosts (Pathbar* self,
                            const gchar* non_ghost_path,
                            gboolean is_search);
AdaptativePathbar* adaptative_pathbar_new (void);
AdaptativePathbar* adaptative_pathbar_construct (GType object_type);
static GObject * adaptative_pathbar_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void adaptative_pathbar_finalize (GObject * obj);
void pathbar_get_complete_path (Pathbar* self,
                                gchar* * _complete_path);
gchar* pathbar_get_selected_child (Pathbar* self,
                                   const gchar* current_path);
static gchar* pathbar_real_get_selected_child (Pathbar* self,
                                        const gchar* current_path);
static gchar* _pathbar_get_selected_child (const gchar* current_path,
                                    const gchar* complete_path);
void pathbar_populate_pathbar_menu (gboolean is_folder,
                                    GMenu* * menu);
static void pathbar_add_copy_path_section (GMenu* * menu);
static void pathbar_add_open_config_section (GMenu* * menu);

static inline gpointer
adaptative_pathbar_get_instance_private (AdaptativePathbar* self)
{
	return G_STRUCT_MEMBER_P (self, AdaptativePathbar_private_offset);
}

static void
adaptative_pathbar_create_large_pathbar (AdaptativePathbar* self)
{
	const gchar* _tmp0_;
	ViewType _tmp1_;
	const gchar* _tmp2_;
	LargePathbar* _tmp3_;
	LargePathbar* _tmp4_;
	LargePathbar* _tmp5_;
	LargePathbar* _tmp6_;
	LargePathbar* _tmp7_;
#line 41 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 43 "../editor/adaptative-pathbar.vala"
	_tmp0_ = self->priv->complete_path;
#line 43 "../editor/adaptative-pathbar.vala"
	_tmp1_ = self->priv->current_type;
#line 43 "../editor/adaptative-pathbar.vala"
	_tmp2_ = self->priv->current_path;
#line 43 "../editor/adaptative-pathbar.vala"
	_tmp3_ = large_pathbar_new (_tmp0_, _tmp1_, _tmp2_);
#line 43 "../editor/adaptative-pathbar.vala"
	g_object_ref_sink (_tmp3_);
#line 43 "../editor/adaptative-pathbar.vala"
	_g_object_unref0 (self->priv->large_pathbar);
#line 43 "../editor/adaptative-pathbar.vala"
	self->priv->large_pathbar = _tmp3_;
#line 44 "../editor/adaptative-pathbar.vala"
	_tmp4_ = self->priv->large_pathbar;
#line 44 "../editor/adaptative-pathbar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_FILL);
#line 45 "../editor/adaptative-pathbar.vala"
	_tmp5_ = self->priv->large_pathbar;
#line 45 "../editor/adaptative-pathbar.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp5_, TRUE);
#line 46 "../editor/adaptative-pathbar.vala"
	_tmp6_ = self->priv->large_pathbar;
#line 46 "../editor/adaptative-pathbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp6_);
#line 47 "../editor/adaptative-pathbar.vala"
	_tmp7_ = self->priv->large_pathbar;
#line 47 "../editor/adaptative-pathbar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp7_);
#line 48 "../editor/adaptative-pathbar.vala"
	self->priv->large_pathbar_created = TRUE;
#line 274 "adaptative-pathbar.c"
}

static void
adaptative_pathbar_create_short_pathbar (AdaptativePathbar* self)
{
	const gchar* _tmp0_;
	ViewType _tmp1_;
	const gchar* _tmp2_;
	ShortPathbar* _tmp3_;
	ShortPathbar* _tmp4_;
	ShortPathbar* _tmp5_;
	ShortPathbar* _tmp6_;
#line 51 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 53 "../editor/adaptative-pathbar.vala"
	_tmp0_ = self->priv->complete_path;
#line 53 "../editor/adaptative-pathbar.vala"
	_tmp1_ = self->priv->current_type;
#line 53 "../editor/adaptative-pathbar.vala"
	_tmp2_ = self->priv->current_path;
#line 53 "../editor/adaptative-pathbar.vala"
	_tmp3_ = short_pathbar_new (_tmp0_, _tmp1_, _tmp2_);
#line 53 "../editor/adaptative-pathbar.vala"
	g_object_ref_sink (_tmp3_);
#line 53 "../editor/adaptative-pathbar.vala"
	_g_object_unref0 (self->priv->short_pathbar);
#line 53 "../editor/adaptative-pathbar.vala"
	self->priv->short_pathbar = _tmp3_;
#line 54 "../editor/adaptative-pathbar.vala"
	_tmp4_ = self->priv->short_pathbar;
#line 54 "../editor/adaptative-pathbar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 55 "../editor/adaptative-pathbar.vala"
	_tmp5_ = self->priv->short_pathbar;
#line 55 "../editor/adaptative-pathbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp5_);
#line 56 "../editor/adaptative-pathbar.vala"
	_tmp6_ = self->priv->short_pathbar;
#line 56 "../editor/adaptative-pathbar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp6_);
#line 57 "../editor/adaptative-pathbar.vala"
	self->priv->short_pathbar_created = TRUE;
#line 317 "adaptative-pathbar.c"
}

static void
adaptative_pathbar_create_initial_pathbar (AdaptativePathbar* self)
{
#line 60 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 62 "../editor/adaptative-pathbar.vala"
	if (self->priv->thin_window) {
#line 327 "adaptative-pathbar.c"
		ShortPathbar* _tmp0_;
#line 64 "../editor/adaptative-pathbar.vala"
		adaptative_pathbar_create_short_pathbar (self);
#line 65 "../editor/adaptative-pathbar.vala"
		_tmp0_ = self->priv->short_pathbar;
#line 65 "../editor/adaptative-pathbar.vala"
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp0_);
#line 335 "adaptative-pathbar.c"
	} else {
		LargePathbar* _tmp1_;
#line 69 "../editor/adaptative-pathbar.vala"
		adaptative_pathbar_create_large_pathbar (self);
#line 70 "../editor/adaptative-pathbar.vala"
		_tmp1_ = self->priv->large_pathbar;
#line 70 "../editor/adaptative-pathbar.vala"
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp1_);
#line 344 "adaptative-pathbar.c"
	}
}

static void
adaptative_pathbar_real_set_window_size (AdaptativeWidget* base,
                                         AdaptativeWidgetWindowSize new_size)
{
	AdaptativePathbar * self;
	gboolean _thin_window = FALSE;
#line 79 "../editor/adaptative-pathbar.vala"
	self = (AdaptativePathbar*) base;
#line 81 "../editor/adaptative-pathbar.vala"
	if (self->priv->window_size_not_given) {
#line 83 "../editor/adaptative-pathbar.vala"
		self->priv->thin_window = adaptative_widget_window_size_is_extra_thin (new_size);
#line 84 "../editor/adaptative-pathbar.vala"
		self->priv->window_size_not_given = FALSE;
#line 85 "../editor/adaptative-pathbar.vala"
		if (self->priv->start_infos_not_given) {
#line 86 "../editor/adaptative-pathbar.vala"
			return;
#line 366 "adaptative-pathbar.c"
		}
#line 87 "../editor/adaptative-pathbar.vala"
		adaptative_pathbar_create_initial_pathbar (self);
#line 88 "../editor/adaptative-pathbar.vala"
		return;
#line 372 "adaptative-pathbar.c"
	}
#line 91 "../editor/adaptative-pathbar.vala"
	_thin_window = adaptative_widget_window_size_is_extra_thin (new_size);
#line 92 "../editor/adaptative-pathbar.vala"
	if (self->priv->thin_window == _thin_window) {
#line 93 "../editor/adaptative-pathbar.vala"
		return;
#line 380 "adaptative-pathbar.c"
	}
#line 94 "../editor/adaptative-pathbar.vala"
	self->priv->thin_window = _thin_window;
#line 96 "../editor/adaptative-pathbar.vala"
	if (self->priv->start_infos_not_given) {
#line 97 "../editor/adaptative-pathbar.vala"
		return;
#line 388 "adaptative-pathbar.c"
	}
#line 99 "../editor/adaptative-pathbar.vala"
	if (_thin_window) {
#line 392 "adaptative-pathbar.c"
		ShortPathbar* _tmp0_;
#line 101 "../editor/adaptative-pathbar.vala"
		if (!self->priv->short_pathbar_created) {
#line 102 "../editor/adaptative-pathbar.vala"
			adaptative_pathbar_create_short_pathbar (self);
#line 398 "adaptative-pathbar.c"
		}
#line 103 "../editor/adaptative-pathbar.vala"
		_tmp0_ = self->priv->short_pathbar;
#line 103 "../editor/adaptative-pathbar.vala"
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp0_);
#line 404 "adaptative-pathbar.c"
	} else {
		LargePathbar* _tmp1_;
#line 107 "../editor/adaptative-pathbar.vala"
		if (!self->priv->large_pathbar_created) {
#line 108 "../editor/adaptative-pathbar.vala"
			adaptative_pathbar_create_large_pathbar (self);
#line 411 "adaptative-pathbar.c"
		}
#line 109 "../editor/adaptative-pathbar.vala"
		_tmp1_ = self->priv->large_pathbar;
#line 109 "../editor/adaptative-pathbar.vala"
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp1_);
#line 417 "adaptative-pathbar.c"
	}
}

static void
adaptative_pathbar_real_set_path (Pathbar* base,
                                  ViewType type,
                                  const gchar* path)
{
	AdaptativePathbar * self;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
#line 121 "../editor/adaptative-pathbar.vala"
	self = (AdaptativePathbar*) base;
#line 121 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (path != NULL);
#line 123 "../editor/adaptative-pathbar.vala"
	self->priv->current_type = type;
#line 124 "../editor/adaptative-pathbar.vala"
	_tmp0_ = g_strdup (path);
#line 124 "../editor/adaptative-pathbar.vala"
	_g_free0 (self->priv->current_path);
#line 124 "../editor/adaptative-pathbar.vala"
	self->priv->current_path = _tmp0_;
#line 126 "../editor/adaptative-pathbar.vala"
	_tmp3_ = self->priv->complete_path;
#line 126 "../editor/adaptative-pathbar.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 126 "../editor/adaptative-pathbar.vala"
		_tmp2_ = TRUE;
#line 449 "adaptative-pathbar.c"
	} else {
#line 127 "../editor/adaptative-pathbar.vala"
		_tmp2_ = !g_str_has_suffix (path, "/");
#line 453 "adaptative-pathbar.c"
	}
#line 126 "../editor/adaptative-pathbar.vala"
	if (_tmp2_) {
#line 126 "../editor/adaptative-pathbar.vala"
		_tmp1_ = TRUE;
#line 459 "adaptative-pathbar.c"
	} else {
		const gchar* _tmp4_;
#line 128 "../editor/adaptative-pathbar.vala"
		_tmp4_ = self->priv->complete_path;
#line 128 "../editor/adaptative-pathbar.vala"
		_tmp1_ = !g_str_has_prefix (_tmp4_, path);
#line 466 "adaptative-pathbar.c"
	}
#line 126 "../editor/adaptative-pathbar.vala"
	if (_tmp1_) {
#line 470 "adaptative-pathbar.c"
		gchar* _tmp5_;
#line 129 "../editor/adaptative-pathbar.vala"
		_tmp5_ = g_strdup (path);
#line 129 "../editor/adaptative-pathbar.vala"
		_g_free0 (self->priv->complete_path);
#line 129 "../editor/adaptative-pathbar.vala"
		self->priv->complete_path = _tmp5_;
#line 478 "adaptative-pathbar.c"
	}
#line 131 "../editor/adaptative-pathbar.vala"
	if (self->priv->start_infos_not_given) {
#line 133 "../editor/adaptative-pathbar.vala"
		self->priv->start_infos_not_given = FALSE;
#line 134 "../editor/adaptative-pathbar.vala"
		if (self->priv->window_size_not_given) {
#line 135 "../editor/adaptative-pathbar.vala"
			return;
#line 488 "adaptative-pathbar.c"
		}
#line 136 "../editor/adaptative-pathbar.vala"
		adaptative_pathbar_create_initial_pathbar (self);
#line 137 "../editor/adaptative-pathbar.vala"
		return;
#line 494 "adaptative-pathbar.c"
	}
#line 140 "../editor/adaptative-pathbar.vala"
	if (self->priv->window_size_not_given) {
#line 141 "../editor/adaptative-pathbar.vala"
		return;
#line 500 "adaptative-pathbar.c"
	}
#line 143 "../editor/adaptative-pathbar.vala"
	if (self->priv->large_pathbar_created) {
#line 504 "adaptative-pathbar.c"
		LargePathbar* _tmp6_;
#line 144 "../editor/adaptative-pathbar.vala"
		_tmp6_ = self->priv->large_pathbar;
#line 144 "../editor/adaptative-pathbar.vala"
		pathbar_set_path ((Pathbar*) _tmp6_, type, path);
#line 510 "adaptative-pathbar.c"
	}
#line 145 "../editor/adaptative-pathbar.vala"
	if (self->priv->short_pathbar_created) {
#line 514 "adaptative-pathbar.c"
		ShortPathbar* _tmp7_;
#line 146 "../editor/adaptative-pathbar.vala"
		_tmp7_ = self->priv->short_pathbar;
#line 146 "../editor/adaptative-pathbar.vala"
		pathbar_set_path ((Pathbar*) _tmp7_, type, path);
#line 520 "adaptative-pathbar.c"
	}
}

static gboolean
adaptative_pathbar_real_has_popover (Pathbar* base)
{
	AdaptativePathbar * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 153 "../editor/adaptative-pathbar.vala"
	self = (AdaptativePathbar*) base;
#line 155 "../editor/adaptative-pathbar.vala"
	if (self->priv->large_pathbar_created) {
#line 535 "adaptative-pathbar.c"
		LargePathbar* _tmp2_;
#line 155 "../editor/adaptative-pathbar.vala"
		_tmp2_ = self->priv->large_pathbar;
#line 155 "../editor/adaptative-pathbar.vala"
		_tmp1_ = pathbar_has_popover ((Pathbar*) _tmp2_);
#line 541 "adaptative-pathbar.c"
	} else {
#line 155 "../editor/adaptative-pathbar.vala"
		_tmp1_ = FALSE;
#line 545 "adaptative-pathbar.c"
	}
#line 155 "../editor/adaptative-pathbar.vala"
	if (_tmp1_) {
#line 155 "../editor/adaptative-pathbar.vala"
		_tmp0_ = TRUE;
#line 551 "adaptative-pathbar.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 156 "../editor/adaptative-pathbar.vala"
		if (self->priv->short_pathbar_created) {
#line 556 "adaptative-pathbar.c"
			ShortPathbar* _tmp4_;
#line 156 "../editor/adaptative-pathbar.vala"
			_tmp4_ = self->priv->short_pathbar;
#line 156 "../editor/adaptative-pathbar.vala"
			_tmp3_ = pathbar_has_popover ((Pathbar*) _tmp4_);
#line 562 "adaptative-pathbar.c"
		} else {
#line 156 "../editor/adaptative-pathbar.vala"
			_tmp3_ = FALSE;
#line 566 "adaptative-pathbar.c"
		}
#line 156 "../editor/adaptative-pathbar.vala"
		_tmp0_ = _tmp3_;
#line 570 "adaptative-pathbar.c"
	}
#line 155 "../editor/adaptative-pathbar.vala"
	result = _tmp0_;
#line 155 "../editor/adaptative-pathbar.vala"
	return result;
#line 576 "adaptative-pathbar.c"
}

static void
adaptative_pathbar_real_close_menu (Pathbar* base)
{
	AdaptativePathbar * self;
#line 159 "../editor/adaptative-pathbar.vala"
	self = (AdaptativePathbar*) base;
#line 161 "../editor/adaptative-pathbar.vala"
	if (self->priv->large_pathbar_created) {
#line 587 "adaptative-pathbar.c"
		LargePathbar* _tmp0_;
#line 162 "../editor/adaptative-pathbar.vala"
		_tmp0_ = self->priv->large_pathbar;
#line 162 "../editor/adaptative-pathbar.vala"
		pathbar_close_menu ((Pathbar*) _tmp0_);
#line 593 "adaptative-pathbar.c"
	}
#line 163 "../editor/adaptative-pathbar.vala"
	if (self->priv->short_pathbar_created) {
#line 597 "adaptative-pathbar.c"
		ShortPathbar* _tmp1_;
#line 164 "../editor/adaptative-pathbar.vala"
		_tmp1_ = self->priv->short_pathbar;
#line 164 "../editor/adaptative-pathbar.vala"
		pathbar_close_menu ((Pathbar*) _tmp1_);
#line 603 "adaptative-pathbar.c"
	}
}

static void
adaptative_pathbar_real_toggle_menu (Pathbar* base)
{
	AdaptativePathbar * self;
#line 167 "../editor/adaptative-pathbar.vala"
	self = (AdaptativePathbar*) base;
#line 169 "../editor/adaptative-pathbar.vala"
	if (self->priv->thin_window) {
#line 615 "adaptative-pathbar.c"
		ShortPathbar* _tmp0_;
#line 171 "../editor/adaptative-pathbar.vala"
		if (!self->priv->short_pathbar_created) {
#line 172 "../editor/adaptative-pathbar.vala"
			g_assert_not_reached ();
#line 621 "adaptative-pathbar.c"
		}
#line 173 "../editor/adaptative-pathbar.vala"
		_tmp0_ = self->priv->short_pathbar;
#line 173 "../editor/adaptative-pathbar.vala"
		pathbar_toggle_menu ((Pathbar*) _tmp0_);
#line 627 "adaptative-pathbar.c"
	} else {
		LargePathbar* _tmp1_;
#line 177 "../editor/adaptative-pathbar.vala"
		if (!self->priv->large_pathbar_created) {
#line 178 "../editor/adaptative-pathbar.vala"
			g_assert_not_reached ();
#line 634 "adaptative-pathbar.c"
		}
#line 179 "../editor/adaptative-pathbar.vala"
		_tmp1_ = self->priv->large_pathbar;
#line 179 "../editor/adaptative-pathbar.vala"
		pathbar_toggle_menu ((Pathbar*) _tmp1_);
#line 640 "adaptative-pathbar.c"
	}
}

static void
adaptative_pathbar_real_get_complete_path (Pathbar* base,
                                           gchar* * _complete_path)
{
	AdaptativePathbar * self;
	gchar* _vala__complete_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 187 "../editor/adaptative-pathbar.vala"
	self = (AdaptativePathbar*) base;
#line 189 "../editor/adaptative-pathbar.vala"
	_tmp0_ = self->priv->complete_path;
#line 189 "../editor/adaptative-pathbar.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 189 "../editor/adaptative-pathbar.vala"
	_g_free0 (_vala__complete_path);
#line 189 "../editor/adaptative-pathbar.vala"
	_vala__complete_path = _tmp1_;
#line 187 "../editor/adaptative-pathbar.vala"
	if (_complete_path) {
#line 187 "../editor/adaptative-pathbar.vala"
		*_complete_path = _vala__complete_path;
#line 666 "adaptative-pathbar.c"
	} else {
#line 187 "../editor/adaptative-pathbar.vala"
		_g_free0 (_vala__complete_path);
#line 670 "adaptative-pathbar.c"
	}
}

static void
adaptative_pathbar_real_get_fallback_path_and_complete_path (Pathbar* base,
                                                             gchar* * _fallback_path,
                                                             gchar* * _complete_path)
{
	AdaptativePathbar * self;
	gchar* _vala__fallback_path = NULL;
	gchar* _vala__complete_path = NULL;
#line 192 "../editor/adaptative-pathbar.vala"
	self = (AdaptativePathbar*) base;
#line 194 "../editor/adaptative-pathbar.vala"
	if (self->priv->large_pathbar_created) {
#line 686 "adaptative-pathbar.c"
		LargePathbar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
#line 195 "../editor/adaptative-pathbar.vala"
		_tmp0_ = self->priv->large_pathbar;
#line 195 "../editor/adaptative-pathbar.vala"
		pathbar_get_fallback_path_and_complete_path ((Pathbar*) _tmp0_, &_tmp1_, &_tmp2_);
#line 195 "../editor/adaptative-pathbar.vala"
		_g_free0 (_vala__fallback_path);
#line 195 "../editor/adaptative-pathbar.vala"
		_vala__fallback_path = _tmp1_;
#line 195 "../editor/adaptative-pathbar.vala"
		_g_free0 (_vala__complete_path);
#line 195 "../editor/adaptative-pathbar.vala"
		_vala__complete_path = _tmp2_;
#line 702 "adaptative-pathbar.c"
	} else {
#line 196 "../editor/adaptative-pathbar.vala"
		if (self->priv->short_pathbar_created) {
#line 706 "adaptative-pathbar.c"
			ShortPathbar* _tmp3_;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
#line 197 "../editor/adaptative-pathbar.vala"
			_tmp3_ = self->priv->short_pathbar;
#line 197 "../editor/adaptative-pathbar.vala"
			pathbar_get_fallback_path_and_complete_path ((Pathbar*) _tmp3_, &_tmp4_, &_tmp5_);
#line 197 "../editor/adaptative-pathbar.vala"
			_g_free0 (_vala__fallback_path);
#line 197 "../editor/adaptative-pathbar.vala"
			_vala__fallback_path = _tmp4_;
#line 197 "../editor/adaptative-pathbar.vala"
			_g_free0 (_vala__complete_path);
#line 197 "../editor/adaptative-pathbar.vala"
			_vala__complete_path = _tmp5_;
#line 722 "adaptative-pathbar.c"
		} else {
#line 199 "../editor/adaptative-pathbar.vala"
			g_assert_not_reached ();
#line 726 "adaptative-pathbar.c"
		}
	}
#line 192 "../editor/adaptative-pathbar.vala"
	if (_fallback_path) {
#line 192 "../editor/adaptative-pathbar.vala"
		*_fallback_path = _vala__fallback_path;
#line 733 "adaptative-pathbar.c"
	} else {
#line 192 "../editor/adaptative-pathbar.vala"
		_g_free0 (_vala__fallback_path);
#line 737 "adaptative-pathbar.c"
	}
#line 192 "../editor/adaptative-pathbar.vala"
	if (_complete_path) {
#line 192 "../editor/adaptative-pathbar.vala"
		*_complete_path = _vala__complete_path;
#line 743 "adaptative-pathbar.c"
	} else {
#line 192 "../editor/adaptative-pathbar.vala"
		_g_free0 (_vala__complete_path);
#line 747 "adaptative-pathbar.c"
	}
}

static void
adaptative_pathbar_real_update_ghosts (Pathbar* base,
                                       const gchar* non_ghost_path,
                                       gboolean is_search)
{
	AdaptativePathbar * self;
#line 202 "../editor/adaptative-pathbar.vala"
	self = (AdaptativePathbar*) base;
#line 202 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (non_ghost_path != NULL);
#line 204 "../editor/adaptative-pathbar.vala"
	if (self->priv->large_pathbar_created) {
#line 763 "adaptative-pathbar.c"
		LargePathbar* _tmp0_;
#line 205 "../editor/adaptative-pathbar.vala"
		_tmp0_ = self->priv->large_pathbar;
#line 205 "../editor/adaptative-pathbar.vala"
		pathbar_update_ghosts ((Pathbar*) _tmp0_, non_ghost_path, is_search);
#line 769 "adaptative-pathbar.c"
	}
#line 206 "../editor/adaptative-pathbar.vala"
	if (self->priv->short_pathbar_created) {
#line 773 "adaptative-pathbar.c"
		ShortPathbar* _tmp1_;
#line 207 "../editor/adaptative-pathbar.vala"
		_tmp1_ = self->priv->short_pathbar;
#line 207 "../editor/adaptative-pathbar.vala"
		pathbar_update_ghosts ((Pathbar*) _tmp1_, non_ghost_path, is_search);
#line 779 "adaptative-pathbar.c"
	}
}

AdaptativePathbar*
adaptative_pathbar_construct (GType object_type)
{
	AdaptativePathbar * self = NULL;
#line 20 "../editor/adaptative-pathbar.vala"
	self = (AdaptativePathbar*) g_object_new (object_type, NULL);
#line 20 "../editor/adaptative-pathbar.vala"
	return self;
#line 791 "adaptative-pathbar.c"
}

AdaptativePathbar*
adaptative_pathbar_new (void)
{
#line 20 "../editor/adaptative-pathbar.vala"
	return adaptative_pathbar_construct (TYPE_ADAPTATIVE_PATHBAR);
#line 799 "adaptative-pathbar.c"
}

static GObject *
adaptative_pathbar_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AdaptativePathbar * self;
#line 22 "../editor/adaptative-pathbar.vala"
	parent_class = G_OBJECT_CLASS (adaptative_pathbar_parent_class);
#line 22 "../editor/adaptative-pathbar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 22 "../editor/adaptative-pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADAPTATIVE_PATHBAR, AdaptativePathbar);
#line 24 "../editor/adaptative-pathbar.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 25 "../editor/adaptative-pathbar.vala"
	gtk_stack_set_hhomogeneous ((GtkStack*) self, FALSE);
#line 22 "../editor/adaptative-pathbar.vala"
	return obj;
#line 822 "adaptative-pathbar.c"
}

static void
adaptative_pathbar_class_init (AdaptativePathbarClass * klass,
                               gpointer klass_data)
{
#line 20 "../editor/adaptative-pathbar.vala"
	adaptative_pathbar_parent_class = g_type_class_peek_parent (klass);
#line 20 "../editor/adaptative-pathbar.vala"
	g_type_class_adjust_private_offset (klass, &AdaptativePathbar_private_offset);
#line 20 "../editor/adaptative-pathbar.vala"
	G_OBJECT_CLASS (klass)->constructor = adaptative_pathbar_constructor;
#line 20 "../editor/adaptative-pathbar.vala"
	G_OBJECT_CLASS (klass)->finalize = adaptative_pathbar_finalize;
#line 837 "adaptative-pathbar.c"
}

static void
adaptative_pathbar_pathbar_interface_init (PathbarIface * iface,
                                           gpointer iface_data)
{
#line 20 "../editor/adaptative-pathbar.vala"
	adaptative_pathbar_pathbar_parent_iface = g_type_interface_peek_parent (iface);
#line 20 "../editor/adaptative-pathbar.vala"
	iface->set_path = (void (*) (Pathbar*, ViewType, const gchar*)) adaptative_pathbar_real_set_path;
#line 20 "../editor/adaptative-pathbar.vala"
	iface->has_popover = (gboolean (*) (Pathbar*)) adaptative_pathbar_real_has_popover;
#line 20 "../editor/adaptative-pathbar.vala"
	iface->close_menu = (void (*) (Pathbar*)) adaptative_pathbar_real_close_menu;
#line 20 "../editor/adaptative-pathbar.vala"
	iface->toggle_menu = (void (*) (Pathbar*)) adaptative_pathbar_real_toggle_menu;
#line 20 "../editor/adaptative-pathbar.vala"
	iface->get_complete_path = (void (*) (Pathbar*, gchar* *)) adaptative_pathbar_real_get_complete_path;
#line 20 "../editor/adaptative-pathbar.vala"
	iface->get_fallback_path_and_complete_path = (void (*) (Pathbar*, gchar* *, gchar* *)) adaptative_pathbar_real_get_fallback_path_and_complete_path;
#line 20 "../editor/adaptative-pathbar.vala"
	iface->update_ghosts = (void (*) (Pathbar*, const gchar*, gboolean)) adaptative_pathbar_real_update_ghosts;
#line 860 "adaptative-pathbar.c"
}

static void
adaptative_pathbar_adaptative_widget_interface_init (AdaptativeWidgetIface * iface,
                                                     gpointer iface_data)
{
#line 20 "../editor/adaptative-pathbar.vala"
	adaptative_pathbar_adaptative_widget_parent_iface = g_type_interface_peek_parent (iface);
#line 20 "../editor/adaptative-pathbar.vala"
	iface->set_window_size = (void (*) (AdaptativeWidget*, AdaptativeWidgetWindowSize)) adaptative_pathbar_real_set_window_size;
#line 871 "adaptative-pathbar.c"
}

static void
adaptative_pathbar_instance_init (AdaptativePathbar * self,
                                  gpointer klass)
{
	gchar* _tmp0_;
#line 20 "../editor/adaptative-pathbar.vala"
	self->priv = adaptative_pathbar_get_instance_private (self);
#line 32 "../editor/adaptative-pathbar.vala"
	self->priv->start_infos_not_given = TRUE;
#line 33 "../editor/adaptative-pathbar.vala"
	self->priv->window_size_not_given = TRUE;
#line 35 "../editor/adaptative-pathbar.vala"
	self->priv->large_pathbar_created = FALSE;
#line 36 "../editor/adaptative-pathbar.vala"
	self->priv->short_pathbar_created = FALSE;
#line 78 "../editor/adaptative-pathbar.vala"
	self->priv->thin_window = FALSE;
#line 119 "../editor/adaptative-pathbar.vala"
	_tmp0_ = g_strdup ("");
#line 119 "../editor/adaptative-pathbar.vala"
	self->priv->complete_path = _tmp0_;
#line 895 "adaptative-pathbar.c"
}

static void
adaptative_pathbar_finalize (GObject * obj)
{
	AdaptativePathbar * self;
#line 20 "../editor/adaptative-pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADAPTATIVE_PATHBAR, AdaptativePathbar);
#line 38 "../editor/adaptative-pathbar.vala"
	_g_object_unref0 (self->priv->large_pathbar);
#line 39 "../editor/adaptative-pathbar.vala"
	_g_object_unref0 (self->priv->short_pathbar);
#line 118 "../editor/adaptative-pathbar.vala"
	_g_free0 (self->priv->current_path);
#line 119 "../editor/adaptative-pathbar.vala"
	_g_free0 (self->priv->complete_path);
#line 20 "../editor/adaptative-pathbar.vala"
	G_OBJECT_CLASS (adaptative_pathbar_parent_class)->finalize (obj);
#line 914 "adaptative-pathbar.c"
}

GType
adaptative_pathbar_get_type (void)
{
	static volatile gsize adaptative_pathbar_type_id__volatile = 0;
	if (g_once_init_enter (&adaptative_pathbar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AdaptativePathbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adaptative_pathbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdaptativePathbar), 0, (GInstanceInitFunc) adaptative_pathbar_instance_init, NULL };
		static const GInterfaceInfo pathbar_info = { (GInterfaceInitFunc) adaptative_pathbar_pathbar_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo adaptative_widget_info = { (GInterfaceInitFunc) adaptative_pathbar_adaptative_widget_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType adaptative_pathbar_type_id;
		adaptative_pathbar_type_id = g_type_register_static (gtk_stack_get_type (), "AdaptativePathbar", &g_define_type_info, 0);
		g_type_add_interface_static (adaptative_pathbar_type_id, TYPE_PATHBAR, &pathbar_info);
		g_type_add_interface_static (adaptative_pathbar_type_id, TYPE_ADAPTATIVE_WIDGET, &adaptative_widget_info);
		AdaptativePathbar_private_offset = g_type_add_instance_private (adaptative_pathbar_type_id, sizeof (AdaptativePathbarPrivate));
		g_once_init_leave (&adaptative_pathbar_type_id__volatile, adaptative_pathbar_type_id);
	}
	return adaptative_pathbar_type_id__volatile;
}

gboolean
pathbar_has_popover (Pathbar* self)
{
#line 214 "../editor/adaptative-pathbar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 214 "../editor/adaptative-pathbar.vala"
	return PATHBAR_GET_INTERFACE (self)->has_popover (self);
#line 942 "adaptative-pathbar.c"
}

void
pathbar_close_menu (Pathbar* self)
{
#line 215 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 215 "../editor/adaptative-pathbar.vala"
	PATHBAR_GET_INTERFACE (self)->close_menu (self);
#line 952 "adaptative-pathbar.c"
}

void
pathbar_toggle_menu (Pathbar* self)
{
#line 216 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 216 "../editor/adaptative-pathbar.vala"
	PATHBAR_GET_INTERFACE (self)->toggle_menu (self);
#line 962 "adaptative-pathbar.c"
}

void
pathbar_set_path (Pathbar* self,
                  ViewType type,
                  const gchar* path)
{
#line 218 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 218 "../editor/adaptative-pathbar.vala"
	PATHBAR_GET_INTERFACE (self)->set_path (self, type, path);
#line 974 "adaptative-pathbar.c"
}

void
pathbar_update_ghosts (Pathbar* self,
                       const gchar* non_ghost_path,
                       gboolean is_search)
{
#line 219 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 219 "../editor/adaptative-pathbar.vala"
	PATHBAR_GET_INTERFACE (self)->update_ghosts (self, non_ghost_path, is_search);
#line 986 "adaptative-pathbar.c"
}

void
pathbar_get_complete_path (Pathbar* self,
                           gchar* * _complete_path)
{
#line 222 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 222 "../editor/adaptative-pathbar.vala"
	PATHBAR_GET_INTERFACE (self)->get_complete_path (self, _complete_path);
#line 997 "adaptative-pathbar.c"
}

void
pathbar_get_fallback_path_and_complete_path (Pathbar* self,
                                             gchar* * _fallback_path,
                                             gchar* * _complete_path)
{
#line 223 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (self != NULL);
#line 223 "../editor/adaptative-pathbar.vala"
	PATHBAR_GET_INTERFACE (self)->get_fallback_path_and_complete_path (self, _fallback_path, _complete_path);
#line 1009 "adaptative-pathbar.c"
}

static gchar*
pathbar_real_get_selected_child (Pathbar* self,
                                 const gchar* current_path)
{
	gchar* result = NULL;
	gchar* complete_path = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 225 "../editor/adaptative-pathbar.vala"
	g_return_val_if_fail (current_path != NULL, NULL);
#line 228 "../editor/adaptative-pathbar.vala"
	pathbar_get_complete_path (self, &_tmp0_);
#line 228 "../editor/adaptative-pathbar.vala"
	_g_free0 (complete_path);
#line 228 "../editor/adaptative-pathbar.vala"
	complete_path = _tmp0_;
#line 229 "../editor/adaptative-pathbar.vala"
	_tmp1_ = _pathbar_get_selected_child (current_path, complete_path);
#line 229 "../editor/adaptative-pathbar.vala"
	result = _tmp1_;
#line 229 "../editor/adaptative-pathbar.vala"
	_g_free0 (complete_path);
#line 229 "../editor/adaptative-pathbar.vala"
	return result;
#line 1036 "adaptative-pathbar.c"
}

gchar*
pathbar_get_selected_child (Pathbar* self,
                            const gchar* current_path)
{
#line 225 "../editor/adaptative-pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 225 "../editor/adaptative-pathbar.vala"
	return PATHBAR_GET_INTERFACE (self)->get_selected_child (self, current_path);
#line 1047 "adaptative-pathbar.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1071 "adaptative-pathbar.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 1079 "adaptative-pathbar.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 1085 "adaptative-pathbar.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
#line 1428 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1429 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1429 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1429 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1430 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1431 "glib-2.0.vapi"
		start = string_length + start;
#line 1113 "adaptative-pathbar.c"
	}
#line 1433 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1434 "glib-2.0.vapi"
		end = string_length + end;
#line 1119 "adaptative-pathbar.c"
	}
#line 1436 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1125 "adaptative-pathbar.c"
	} else {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1129 "adaptative-pathbar.c"
	}
#line 1436 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1437 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1137 "adaptative-pathbar.c"
	} else {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1141 "adaptative-pathbar.c"
	}
#line 1437 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1438 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1439 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1439 "glib-2.0.vapi"
	result = _tmp4_;
#line 1439 "glib-2.0.vapi"
	return result;
#line 1153 "adaptative-pathbar.c"
}

static gchar*
_pathbar_get_selected_child (const gchar* current_path,
                             const gchar* complete_path)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gint index_of_last_slash = 0;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_ = NULL;
#line 231 "../editor/adaptative-pathbar.vala"
	g_return_val_if_fail (current_path != NULL, NULL);
#line 231 "../editor/adaptative-pathbar.vala"
	g_return_val_if_fail (complete_path != NULL, NULL);
#line 233 "../editor/adaptative-pathbar.vala"
	if (!g_str_has_prefix (complete_path, current_path)) {
#line 233 "../editor/adaptative-pathbar.vala"
		_tmp0_ = TRUE;
#line 1174 "adaptative-pathbar.c"
	} else {
#line 233 "../editor/adaptative-pathbar.vala"
		_tmp0_ = g_strcmp0 (complete_path, current_path) == 0;
#line 1178 "adaptative-pathbar.c"
	}
#line 233 "../editor/adaptative-pathbar.vala"
	if (_tmp0_) {
#line 1182 "adaptative-pathbar.c"
		gchar* _tmp1_;
#line 234 "../editor/adaptative-pathbar.vala"
		_tmp1_ = g_strdup ("");
#line 234 "../editor/adaptative-pathbar.vala"
		result = _tmp1_;
#line 234 "../editor/adaptative-pathbar.vala"
		return result;
#line 1190 "adaptative-pathbar.c"
	}
#line 235 "../editor/adaptative-pathbar.vala"
	_tmp2_ = strlen (current_path);
#line 235 "../editor/adaptative-pathbar.vala"
	_tmp3_ = _tmp2_;
#line 235 "../editor/adaptative-pathbar.vala"
	index_of_last_slash = string_index_of (complete_path, "/", _tmp3_);
#line 236 "../editor/adaptative-pathbar.vala"
	if (index_of_last_slash == -1) {
#line 1200 "adaptative-pathbar.c"
		gchar* _tmp5_;
#line 236 "../editor/adaptative-pathbar.vala"
		_tmp5_ = g_strdup (complete_path);
#line 236 "../editor/adaptative-pathbar.vala"
		_g_free0 (_tmp4_);
#line 236 "../editor/adaptative-pathbar.vala"
		_tmp4_ = _tmp5_;
#line 1208 "adaptative-pathbar.c"
	} else {
		gchar* _tmp6_;
#line 236 "../editor/adaptative-pathbar.vala"
		_tmp6_ = string_slice (complete_path, (glong) 0, (glong) (index_of_last_slash + 1));
#line 236 "../editor/adaptative-pathbar.vala"
		_g_free0 (_tmp4_);
#line 236 "../editor/adaptative-pathbar.vala"
		_tmp4_ = _tmp6_;
#line 1217 "adaptative-pathbar.c"
	}
#line 236 "../editor/adaptative-pathbar.vala"
	result = _tmp4_;
#line 236 "../editor/adaptative-pathbar.vala"
	return result;
#line 1223 "adaptative-pathbar.c"
}

void
pathbar_populate_pathbar_menu (gboolean is_folder,
                               GMenu* * menu)
{
#line 240 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (*menu != NULL);
#line 242 "../editor/adaptative-pathbar.vala"
	pathbar_add_copy_path_section (menu);
#line 243 "../editor/adaptative-pathbar.vala"
	if (is_folder) {
#line 244 "../editor/adaptative-pathbar.vala"
		pathbar_add_open_config_section (menu);
#line 1238 "adaptative-pathbar.c"
	}
}

static void
pathbar_add_copy_path_section (GMenu* * menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
#line 247 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (*menu != NULL);
#line 249 "../editor/adaptative-pathbar.vala"
	_tmp0_ = g_menu_new ();
#line 249 "../editor/adaptative-pathbar.vala"
	section = _tmp0_;
#line 251 "../editor/adaptative-pathbar.vala"
	g_menu_append (section, _ ("Copy current path"), "base.copy-alt");
#line 253 "../editor/adaptative-pathbar.vala"
	g_menu_freeze (section);
#line 254 "../editor/adaptative-pathbar.vala"
	g_menu_append_section (*menu, NULL, (GMenuModel*) section);
#line 247 "../editor/adaptative-pathbar.vala"
	_g_object_unref0 (section);
#line 1261 "adaptative-pathbar.c"
}

static void
pathbar_add_open_config_section (GMenu* * menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
	GMenu* _tmp1_;
	GMenu* _tmp2_;
	GMenu* _tmp3_;
#line 257 "../editor/adaptative-pathbar.vala"
	g_return_if_fail (*menu != NULL);
#line 260 "../editor/adaptative-pathbar.vala"
	return;
#line 1276 "adaptative-pathbar.c"
}

static void
pathbar_default_init (PathbarIface * iface,
                      gpointer iface_data)
{
#line 211 "../editor/adaptative-pathbar.vala"
	iface->get_selected_child = pathbar_real_get_selected_child;
#line 1285 "adaptative-pathbar.c"
}

GType
pathbar_get_type (void)
{
	static volatile gsize pathbar_type_id__volatile = 0;
	if (g_once_init_enter (&pathbar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PathbarIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pathbar_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType pathbar_type_id;
		pathbar_type_id = g_type_register_static (G_TYPE_INTERFACE, "Pathbar", &g_define_type_info, 0);
		g_once_init_leave (&pathbar_type_id__volatile, pathbar_type_id);
	}
	return pathbar_type_id__volatile;
}

