/* browser-content.c generated by valac 0.45.91, the Vala compiler
 * generated from browser-content.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_BROWSER_CONTENT (browser_content_get_type ())
#define BROWSER_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BROWSER_CONTENT, BrowserContent))
#define IS_BROWSER_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BROWSER_CONTENT))
#define BROWSER_CONTENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BROWSER_CONTENT, BrowserContentIface))

typedef struct _BrowserContent BrowserContent;
typedef struct _BrowserContentIface BrowserContentIface;

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())
typedef enum  {
	VIEW_TYPE_OBJECT,
	VIEW_TYPE_FOLDER,
	VIEW_TYPE_SEARCH,
	VIEW_TYPE_CONFIG
} ViewType;

#define TYPE_VIEW_TYPE (view_type_get_type ())

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _BrowserContentIface {
	GTypeInterface parent_iface;
	void (*prepare_folder_view) (BrowserContent* self, GListStore* key_model, gboolean is_ancestor);
	void (*prepare_object_view) (BrowserContent* self, const gchar* full_name, guint16 context_id, GVariant* properties, gboolean is_parent);
	void (*set_path) (BrowserContent* self, ViewType type, const gchar* path);
	gchar* (*get_selected_row_name) (BrowserContent* self);
	void (*select_row_named) (BrowserContent* self, const gchar* selected, guint16 last_context_id, gboolean grab_focus_if_needed);
	void (*select_first_row) (BrowserContent* self);
	void (*row_grab_focus) (BrowserContent* self);
	gboolean (*toggle_row_popover) (BrowserContent* self);
	void (*discard_row_popover) (BrowserContent* self);
	void (*invalidate_popovers) (BrowserContent* self);
	gboolean (*check_reload_folder) (BrowserContent* self, GVariant* fresh_key_model);
	gboolean (*check_reload_object) (BrowserContent* self, guint properties_hash);
	gboolean (*handle_copy_text) (BrowserContent* self, gchar* * copy_text);
	gboolean (*handle_alt_copy_text) (BrowserContent* self, gchar* * copy_text);
	gboolean (*next_match) (BrowserContent* self);
	gboolean (*previous_match) (BrowserContent* self);
	gboolean (*return_pressed) (BrowserContent* self);
	ViewType (*get_current_view) (BrowserContent* self);
	void (*set_current_view) (BrowserContent* self, ViewType value);
};

GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST;
GType adaptative_widget_get_type (void) G_GNUC_CONST;
GType view_type_get_type (void) G_GNUC_CONST;
GType browser_content_get_type (void) G_GNUC_CONST;
void browser_content_prepare_folder_view (BrowserContent* self,
                                          GListStore* key_model,
                                          gboolean is_ancestor);
void browser_content_prepare_object_view (BrowserContent* self,
                                          const gchar* full_name,
                                          guint16 context_id,
                                          GVariant* properties,
                                          gboolean is_parent);
void browser_content_set_path (BrowserContent* self,
                               ViewType type,
                               const gchar* path);
gchar* browser_content_get_selected_row_name (BrowserContent* self);
void browser_content_select_row_named (BrowserContent* self,
                                       const gchar* selected,
                                       guint16 last_context_id,
                                       gboolean grab_focus_if_needed);
void browser_content_select_first_row (BrowserContent* self);
void browser_content_row_grab_focus (BrowserContent* self);
gboolean browser_content_toggle_row_popover (BrowserContent* self);
void browser_content_discard_row_popover (BrowserContent* self);
void browser_content_invalidate_popovers (BrowserContent* self);
gboolean browser_content_check_reload_folder (BrowserContent* self,
                                              GVariant* fresh_key_model);
gboolean browser_content_check_reload_object (BrowserContent* self,
                                              guint properties_hash);
gboolean browser_content_handle_copy_text (BrowserContent* self,
                                           gchar* * copy_text);
gboolean browser_content_handle_alt_copy_text (BrowserContent* self,
                                               gchar* * copy_text);
gboolean browser_content_next_match (BrowserContent* self);
gboolean browser_content_previous_match (BrowserContent* self);
gboolean browser_content_return_pressed (BrowserContent* self);
ViewType browser_content_get_current_view (BrowserContent* self);
void browser_content_set_current_view (BrowserContent* self,
                                       ViewType value);

void
browser_content_prepare_folder_view (BrowserContent* self,
                                     GListStore* key_model,
                                     gboolean is_ancestor)
{
#line 24 "../editor/browser-content.vala"
	g_return_if_fail (self != NULL);
#line 24 "../editor/browser-content.vala"
	BROWSER_CONTENT_GET_INTERFACE (self)->prepare_folder_view (self, key_model, is_ancestor);
#line 142 "browser-content.c"
}

void
browser_content_prepare_object_view (BrowserContent* self,
                                     const gchar* full_name,
                                     guint16 context_id,
                                     GVariant* properties,
                                     gboolean is_parent)
{
#line 25 "../editor/browser-content.vala"
	g_return_if_fail (self != NULL);
#line 25 "../editor/browser-content.vala"
	BROWSER_CONTENT_GET_INTERFACE (self)->prepare_object_view (self, full_name, context_id, properties, is_parent);
#line 156 "browser-content.c"
}

void
browser_content_set_path (BrowserContent* self,
                          ViewType type,
                          const gchar* path)
{
#line 26 "../editor/browser-content.vala"
	g_return_if_fail (self != NULL);
#line 26 "../editor/browser-content.vala"
	BROWSER_CONTENT_GET_INTERFACE (self)->set_path (self, type, path);
#line 168 "browser-content.c"
}

gchar*
browser_content_get_selected_row_name (BrowserContent* self)
{
#line 32 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->get_selected_row_name (self);
#line 178 "browser-content.c"
}

void
browser_content_select_row_named (BrowserContent* self,
                                  const gchar* selected,
                                  guint16 last_context_id,
                                  gboolean grab_focus_if_needed)
{
#line 33 "../editor/browser-content.vala"
	g_return_if_fail (self != NULL);
#line 33 "../editor/browser-content.vala"
	BROWSER_CONTENT_GET_INTERFACE (self)->select_row_named (self, selected, last_context_id, grab_focus_if_needed);
#line 191 "browser-content.c"
}

void
browser_content_select_first_row (BrowserContent* self)
{
#line 34 "../editor/browser-content.vala"
	g_return_if_fail (self != NULL);
#line 34 "../editor/browser-content.vala"
	BROWSER_CONTENT_GET_INTERFACE (self)->select_first_row (self);
#line 201 "browser-content.c"
}

void
browser_content_row_grab_focus (BrowserContent* self)
{
#line 35 "../editor/browser-content.vala"
	g_return_if_fail (self != NULL);
#line 35 "../editor/browser-content.vala"
	BROWSER_CONTENT_GET_INTERFACE (self)->row_grab_focus (self);
#line 211 "browser-content.c"
}

gboolean
browser_content_toggle_row_popover (BrowserContent* self)
{
#line 40 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->toggle_row_popover (self);
#line 221 "browser-content.c"
}

void
browser_content_discard_row_popover (BrowserContent* self)
{
#line 41 "../editor/browser-content.vala"
	g_return_if_fail (self != NULL);
#line 41 "../editor/browser-content.vala"
	BROWSER_CONTENT_GET_INTERFACE (self)->discard_row_popover (self);
#line 231 "browser-content.c"
}

void
browser_content_invalidate_popovers (BrowserContent* self)
{
#line 42 "../editor/browser-content.vala"
	g_return_if_fail (self != NULL);
#line 42 "../editor/browser-content.vala"
	BROWSER_CONTENT_GET_INTERFACE (self)->invalidate_popovers (self);
#line 241 "browser-content.c"
}

gboolean
browser_content_check_reload_folder (BrowserContent* self,
                                     GVariant* fresh_key_model)
{
#line 48 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->check_reload_folder (self, fresh_key_model);
#line 252 "browser-content.c"
}

gboolean
browser_content_check_reload_object (BrowserContent* self,
                                     guint properties_hash)
{
#line 49 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 49 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->check_reload_object (self, properties_hash);
#line 263 "browser-content.c"
}

gboolean
browser_content_handle_copy_text (BrowserContent* self,
                                  gchar* * copy_text)
{
#line 55 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->handle_copy_text (self, copy_text);
#line 274 "browser-content.c"
}

gboolean
browser_content_handle_alt_copy_text (BrowserContent* self,
                                      gchar* * copy_text)
{
#line 56 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->handle_alt_copy_text (self, copy_text);
#line 285 "browser-content.c"
}

gboolean
browser_content_next_match (BrowserContent* self)
{
#line 58 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->next_match (self);
#line 295 "browser-content.c"
}

gboolean
browser_content_previous_match (BrowserContent* self)
{
#line 59 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->previous_match (self);
#line 305 "browser-content.c"
}

gboolean
browser_content_return_pressed (BrowserContent* self)
{
#line 61 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->return_pressed (self);
#line 315 "browser-content.c"
}

ViewType
browser_content_get_current_view (BrowserContent* self)
{
#line 22 "../editor/browser-content.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 22 "../editor/browser-content.vala"
	return BROWSER_CONTENT_GET_INTERFACE (self)->get_current_view (self);
#line 325 "browser-content.c"
}

void
browser_content_set_current_view (BrowserContent* self,
                                  ViewType value)
{
#line 22 "../editor/browser-content.vala"
	g_return_if_fail (self != NULL);
#line 22 "../editor/browser-content.vala"
	BROWSER_CONTENT_GET_INTERFACE (self)->set_current_view (self, value);
#line 336 "browser-content.c"
}

static void
browser_content_default_init (BrowserContentIface * iface,
                              gpointer iface_data)
{
#line 20 "../editor/browser-content.vala"
	g_object_interface_install_property (iface, g_param_spec_enum ("current-view", "current-view", "current-view", TYPE_VIEW_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 345 "browser-content.c"
}

GType
browser_content_get_type (void)
{
	static volatile gsize browser_content_type_id__volatile = 0;
	if (g_once_init_enter (&browser_content_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BrowserContentIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) browser_content_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType browser_content_type_id;
		browser_content_type_id = g_type_register_static (G_TYPE_INTERFACE, "BrowserContent", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (browser_content_type_id, gtk_widget_get_type ());
		g_type_interface_add_prerequisite (browser_content_type_id, TYPE_ADAPTATIVE_WIDGET);
		g_once_init_leave (&browser_content_type_id__volatile, browser_content_type_id);
	}
	return browser_content_type_id__volatile;
}

